#![allow(unused)]
mod year2022;

#[macro_export]
macro_rules! solve1 {
    ($test:expr) => {
        #[test]
        fn sample_part1() {
            let result = solve1(SAMPLE_INPUT);
            println!("{result}");
            assert_eq!(result, $test);
        }
    };
    ($test:expr, $solution:expr) => {
        #[test]
        fn sample_part1() {
            let result = solve1(SAMPLE_INPUT);
            println!("{result}");
            assert_eq!(result, $test);
        }
        #[test]
        fn real_part1() {
            let now = std::time::SystemTime::now();
            let result = solve1(INPUT);
            println!("{:?}", now.elapsed().unwrap());
            println!("{result}");
            assert_eq!(result, $solution);
        }
    };
}

#[macro_export]
macro_rules! solve2 {
    ($test:expr) => {
        #[test]
        fn sample_part2() {
            let result = solve2(SAMPLE_INPUT);
            println!("{result}");
            assert_eq!(result, $test);
        }
    };
    ($test:expr, $solution:expr) => {
        #[test]
        fn sample_part2() {
            let result = solve2(SAMPLE_INPUT);
            println!("{result}");
            assert_eq!(result, $test);
        }
        #[test]
        fn real_part2() {
            let now = std::time::SystemTime::now();
            let result = solve2(INPUT);
            println!("{:?}", now.elapsed().unwrap());
            println!("{result}");
            assert_eq!(result, $solution);
        }
    };
}