use crate::{solve1, solve2};
static INPUT: &str = include_str!("../../data/year2022/day01.txt");
static SAMPLE_INPUT: &str = include_str!("../../data/year2022/day01_test.txt");

fn calories_per_elf(input: &str) -> impl Iterator<Item = i64> + '_ {
    input.split("\r\n\r\n").map(|group| {
        group
            .split("\r\n")
            .map(|num| num.parse::<i64>().unwrap())
            .sum::<i64>()
    })
}

fn solve1(input: &str) -> i64 {
    calories_per_elf(input).max().unwrap()
}

fn solve2(input: &str) -> i64 {
    let mut cals: Vec<i64> = calories_per_elf(input).collect();
    cals.sort();
    cals.iter().rev().take(3).sum()
}

solve1!(24000, 71506);
solve2!(45000, 209603);
